import React from 'react';
import { StyleProp, ViewProps, ViewStyle } from 'react-native';
import { InAppContentBlock, InAppContentBlockAction } from './ExponeaType';
interface ContentBlockCarouselProps extends ViewProps {
    placeholderId: string;
    maxMessagesCount?: number;
    scrollDelay?: number;
    overrideDefaultBehavior?: boolean;
    trackActions?: boolean;
    onMessageShown?: (placeholderId: string, contentBlock: InAppContentBlock, index: number, count: number) => void;
    onMessagesChanged?: (count: number, messages: InAppContentBlock[]) => void;
    onNoMessageFound?: (placeholderId: string) => void;
    onError?: (placeholderId: string, contentBlock: InAppContentBlock | undefined, errorMessage: string) => void;
    onCloseClicked?: (placeholderId: string, contentBlock: InAppContentBlock) => void;
    onActionClicked?: (placeholderId: string, contentBlock: InAppContentBlock, action: InAppContentBlockAction) => void;
    filterContentBlocks?: (blocks: InAppContentBlock[]) => InAppContentBlock[];
    sortContentBlocks?: (blocks: InAppContentBlock[]) => InAppContentBlock[];
    style?: StyleProp<ViewStyle> | undefined;
}
export default function ContentBlockCarouselView(props: ContentBlockCarouselProps): React.ReactElement;
export {};
