"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var RNContentBlockCarouselView_1 = __importDefault(require("./RNContentBlockCarouselView"));
function ContentBlockCarouselView(props) {
    var ref = (0, react_1.useRef)(null);
    var placeholderId = props.placeholderId, maxMessagesCount = props.maxMessagesCount, scrollDelay = props.scrollDelay, overrideDefaultBehavior = props.overrideDefaultBehavior, trackActions = props.trackActions, filterContentBlocksFn = props.filterContentBlocks, sortContentBlocksFn = props.sortContentBlocks, viewStyle = props.style, viewProps = __rest(props, ["placeholderId", "maxMessagesCount", "scrollDelay", "overrideDefaultBehavior", "trackActions", "filterContentBlocks", "sortContentBlocks", "style"]);
    var _a = (0, react_1.useState)({}), dimens = _a[0], setDimens = _a[1];
    function _onDimensChanged(event) {
        setDimens({
            width: dimens.width,
            height: event.nativeEvent.height,
        });
    }
    function _onContentBlockEvent(event) {
        var nativeEvent = event.nativeEvent;
        switch (nativeEvent.eventType) {
            case 'onMessageShown':
                props.onMessageShown && nativeEvent.contentBlock && props.onMessageShown(nativeEvent.placeholderId, JSON.parse(nativeEvent.contentBlock), nativeEvent.index, nativeEvent.count);
                break;
            case 'onMessagesChanged':
                props.onMessagesChanged && nativeEvent.contentBlocks && props.onMessagesChanged(nativeEvent.count, JSON.parse(nativeEvent.contentBlocks));
                break;
            case 'onNoMessageFound':
                props.onNoMessageFound && props.onNoMessageFound(nativeEvent.placeholderId);
                break;
            case 'onError':
                var contentBlock = nativeEvent.contentBlock && JSON.parse(nativeEvent.contentBlock);
                props.onError && props.onError(nativeEvent.placeholderId, contentBlock, nativeEvent.errorMessage);
                break;
            case 'onCloseClicked':
                props.onCloseClicked && nativeEvent.contentBlock && props.onCloseClicked(nativeEvent.placeholderId, JSON.parse(nativeEvent.contentBlock));
                break;
            case 'onActionClicked':
                props.onActionClicked && nativeEvent.contentBlock && nativeEvent.contentBlockAction && props.onActionClicked(nativeEvent.placeholderId, JSON.parse(nativeEvent.contentBlock), JSON.parse(nativeEvent.contentBlockAction));
                break;
        }
    }
    function _onContentBlockDataRequestEvent(event) {
        var _a, _b;
        var nativeEvent = event.nativeEvent;
        var response = nativeEvent.data.map(function (each) {
            return JSON.parse(each);
        });
        switch (nativeEvent.requestType) {
            case 'filter':
                response = (_a = (filterContentBlocksFn && filterContentBlocksFn(response))) !== null && _a !== void 0 ? _a : response;
                break;
            case 'sort':
                response = (_b = (sortContentBlocksFn && sortContentBlocksFn(response))) !== null && _b !== void 0 ? _b : response;
                break;
        }
        var normalisedResponse = response.map(function (each) {
            return JSON.stringify(each);
        });
        var viewId = (0, react_native_1.findNodeHandle)(ref.current);
        react_native_1.UIManager.dispatchViewManagerCommand(viewId, nativeEvent.requestType + 'Response', [normalisedResponse]);
    }
    function _mergeViewStyle() {
        return Object.assign({}, viewStyle, {
            width: dimens.width,
            height: dimens.height,
        });
    }
    return (react_1.default.createElement(react_native_1.View, __assign({}, viewProps, { style: _mergeViewStyle() }),
        react_1.default.createElement(RNContentBlockCarouselView_1.default, __assign({ ref: ref, initProps: {
                placeholderId: placeholderId,
                maxMessagesCount: maxMessagesCount,
                scrollDelay: scrollDelay
            }, overrideDefaultBehavior: overrideDefaultBehavior, trackActions: trackActions }, viewProps, { style: _mergeViewStyle(), onDimensChanged: _onDimensChanged, onContentBlockEvent: _onContentBlockEvent, customFilterActive: !!filterContentBlocksFn, customSortActive: !!sortContentBlocksFn, onContentBlockDataRequestEvent: _onContentBlockDataRequestEvent }))));
}
exports.default = ContentBlockCarouselView;
