"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InAppMessageActionDef = void 0;
var ExponeaType_1 = require("./ExponeaType");
var InAppMessageActionDef = /** @class */ (function () {
    function InAppMessageActionDef(type) {
        this.type = type;
    }
    /**
     * Creates InAppMessageAction instance for click action
     */
    InAppMessageActionDef.buildForClick = function (message, buttonText, buttonUrl) {
        var result = new InAppMessageActionDef(ExponeaType_1.InAppMessageActionType.ACTION);
        result.message = __assign({}, message);
        if (buttonText || buttonUrl) {
            result.button = {};
            if (buttonText) {
                result.button.text = buttonText;
            }
            if (buttonUrl) {
                result.button.url = buttonUrl;
            }
        }
        return result;
    };
    InAppMessageActionDef.buildForClose = function (message, buttonText, interaction) {
        var result = new InAppMessageActionDef(ExponeaType_1.InAppMessageActionType.CLOSE);
        result.message = __assign({}, message);
        if (buttonText) {
            result.button = {
                text: buttonText
            };
        }
        result.interaction = interaction;
        return result;
    };
    return InAppMessageActionDef;
}());
exports.InAppMessageActionDef = InAppMessageActionDef;
