import { HostComponent, NativeSyntheticEvent, ViewProps } from 'react-native';
import { DimensEvent } from './RNInAppContentBlocksPlaceholder';
export interface ContentBlockCarouselEvent {
    eventType: string;
    placeholderId?: string;
    contentBlock?: string;
    contentBlockAction?: string;
    errorMessage?: string;
    index?: number;
    count?: number;
    contentBlocks?: string;
}
export interface ContentBlockDataRequestEvent {
    requestType: string;
    data: string[];
}
export interface ContentBlockCarouselInitProps {
    placeholderId: string;
    maxMessagesCount?: number;
    scrollDelay?: number;
}
interface ContentBlockCarouselNativeProps extends ViewProps {
    initProps: ContentBlockCarouselInitProps;
    overrideDefaultBehavior?: boolean;
    trackActions?: boolean;
    customFilterActive: boolean;
    customSortActive: boolean;
    onDimensChanged: (event: NativeSyntheticEvent<DimensEvent>) => void;
    onContentBlockEvent: (event: NativeSyntheticEvent<ContentBlockCarouselEvent>) => void;
    onContentBlockDataRequestEvent: (event: NativeSyntheticEvent<ContentBlockDataRequestEvent>) => void;
}
declare const RNContentBlockCarouselView: HostComponent<ContentBlockCarouselNativeProps>;
export default RNContentBlockCarouselView;
